set theTargetFolder to "/Users/jpagliaro/Documents/Mail to RTF" as POSIX file -- or something else
set delaySeconds to 2
tell application "Mail"
	activate
	set S to selection -- the selected messages
	
	if ((count of S) is 0) then
		display alert "Mail has no selections." message "Select messages in Mail and try again." buttons {"OK"} default button "OK" giving up after 20
	else
		repeat with currentItem in S
			set theSubject to (subject of currentItem)
			-- remove any ":" chars
			set AppleScript's text item delimiters to the ":"
			set the item_list to every text item of theSubject
			set AppleScript's text item delimiters to the "-"
			set theSubject to the item_list as string
			set AppleScript's text item delimiters to ""
			open currentItem -- open the current message in a separate message window
			delay delaySeconds
			tell application "System Events"
				keystroke "s" using {shift down, command down} -- save
				delay delaySeconds
				tell (pop up button 1 of group 1 of sheet 1 of window 1 of process "Mail") -- open pdf dialog
					click
					delay delaySeconds
					tell menu 1
						click menu item "Rich Text Format" -- save as pdf
					end tell
					delay delaySeconds
				end tell
				keystroke "d" using {shift down, command down} -- change directory to desktop
				delay delaySeconds
				set the value of text field 1 of sheet 1 of window 1 of process "Mail" to theSubject
				set theName to value of text field 1 of sheet 1 of window 1 of process "Mail" -- get the save file name we just set
				if (length of theName is 0) then
					set the value of text field 1 of sheet 1 of window 1 of process "Mail" to ((current date) as string) -- set the name to date
				else
					set the value of text field 1 of sheet 1 of window 1 of process "Mail" to "[" & (((current date) as string) & "] " & theName) -- prefix with the date
					--set the value of text field 1 of sheet 1 of window 1 of process "Mail" to theName
				end if
				set theName to value of text field 1 of sheet 1 of window 1 of process "Mail" -- refresh the file name
				keystroke return
				delay delaySeconds
				keystroke "w" using command down
			end tell
			tell application "Finder" -- wait till the file shows in the Finder, then move it to the target directory
				set thePath to (path to desktop as string) & theName
				repeat until (document file thePath exists)
				end repeat
				move document file thePath to theTargetFolder with replacing -- or without replacing if you prefer
			end tell
		end repeat
	end if
	
end tell